(* main *)
    let main () =
    begin

(* We want 1 argument *)
if Array.length (Sys.argv) < 2 then
    failwith "Il manque le nom du fichier!";

    (* SDL Initialisation *)
    Display.sdl_init ();

    (* Image Loading *)
    let img = Sdlloader.load_image Sys.argv.(1) in
    (* Getting dimensions *)
        let (w,h) = Display.get_dims img in
        (* Creating display surface by doublebuffering *)
            let display =
                Sdlvideo.set_video_mode w h [`DOUBLEBUF] in
                (* Displaying image *)
                    Display.show img display;

    Display.wait_key (); (* Waiting for a key *)

(* ---------------------------------------------------------------------------
 * Origin
 *---------------------------------------------------------------------------*)

    let origin_matrix = Matrix.image2tab img in

(* ---------------------------------------------------------------------------
 * Filter binarisation
 *---------------------------------------------------------------------------*)

    let mymatrix = Pretreatments.toBlack origin_matrix in
        Display.show (Matrix.tab2image mymatrix) display;

    Display.wait_key ();

(* ---------------------------------------------------------------------------
 * Applying 3 3 Filter
 *---------------------------------------------------------------------------*)

    let tab2 =  (Filter.main_noise (mymatrix) )  in
       Display.show (Matrix.tab2image tab2) display;

    Display.wait_key ();

(* ---------------------------------------------------------------------------
 * Applying 5 5 Filter
 *---------------------------------------------------------------------------*)
(*
    let tab21 =  (Filter.main_noise (tab2) 5 5)  in
        Display.show (Matrix.tab2image tab21) display;

    Display.wait_key ();
 *)
(* ---------------------------------------------------------------------------
 * Applying 9 7 Filter
 *---------------------------------------------------------------------------*)
(*
    let tab22 =  (Filter.main_noise (tab2) 9 4)  in
        Display.show (Matrix.tab2image tab22) display;

    Display.wait_key ();
*)
(*
(* ---------------------------------------------------------------------------
 * Filter 1 1 1
 *---------------------------------------------------------------------------*)

    let tab3 = Filter.main origin_matrix Filter.moyenne in
        Display.show (Matrix.tab2image tab3) display;

    Display.wait_key();

(* ---------------------------------------------------------------------------
 * Filter 1 2 4
 *---------------------------------------------------------------------------*)

    let tab4 = Filter.main origin_matrix Filter.moyenne_pond in
        Display.show (Matrix.tab2image tab4) display;

    Display.wait_key ();

(* ---------------------------------------------------------------------------
 * Filter 2 5 20
 *---------------------------------------------------------------------------*)

    let tab5 = Filter.main origin_matrix Filter.moyenne_pond2 in
       Display.show (Matrix.tab2image tab5) display;

    Display.wait_key ();

(* ---------------------------------------------------------------------------
 * Filter 2 5 20Binarization
 *---------------------------------------------------------------------------*)

    (* Binarization *)
    let tab6 = Pretreatments.toBlack tab5 in
        Display.show (Matrix.tab2image tab6) display;


    Display.wait_key ();
*)
(* ---------------------------------------------------------------------------
 * Text Recog
 *---------------------------------------------------------------------------*)

   let mymatrix2 = tab2 in
            let matsrc_1coord = Matrix.to1coord mymatrix2 in
            TextProcess.print_lines matsrc_1coord;
            let matsrc_finished = Matrix.to3coord matsrc_1coord in
            Display.show (Matrix.tab2image matsrc_finished) display;

            Display.wait_key ();

            TextProcess.print_columns_call matsrc_1coord
            (TextProcess.search_lines_v2 matsrc_1coord);
            Display.show (Matrix.tab2image (Matrix.to3coord matsrc_1coord)) display;

            Display.wait_key ();

(* ---------------------------------------------------------------------------
 * Recog output
 *---------------------------------------------------------------------------*)
            let outlist = (TextProcess.cfl_call (Matrix.to1coord tab2)) in
            for i = 0 to 2 do
                begin
                    Display.show (Matrix.tab2image (Matrix.to3coord (List.nth
                    outlist i))) display;
                    Display.wait_key();
                end
            done;
    exit 0;
    end

let _ = main ()
