(* Grayscale filtering  *)
let level (r,g,b) = (0.3 *. (float_of_int r)
            +. 0.59 *. (float_of_int g)
            +. 0.11 *. (float_of_int b))/. 255.

let blackNwhite (r,g,b) step =
    let step2 = ref step in
	if (!step2 > 0.75) then
	    begin
	    step2 :=  0.75
	    end;
	if (!step2 < 0.25) then
	    begin
	    step2 :=  0.25
	    end;
	if (level (r,g,b) > !step2) then (255,255,255)
	else (0,0,0)
   (* if (level (r,g,b) > step) then (255,255,255)
        else (0,0,0)*)
(* Grayscale filtering  *)

let averageImg matsrc =
        let nbr = ref 0. in
        for i = 0 to (Array.length matsrc) - 1 do
                for j = 0 to (Array.length matsrc.(0)) - 1 do
                    nbr := !nbr +. level(matsrc.(i).(j))
                done
        done;
        !nbr /. (float_of_int (Array.length matsrc) *. float_of_int
        (Array.length matsrc.(0)))

let toBlack matsrc  =
        let step = averageImg matsrc in
        for i = 0 to (Array.length matsrc) - 1 do
                for j = 0 to (Array.length matsrc.(0)) - 1 do
                     matsrc.(i).(j) <-  blackNwhite matsrc.(i).(j) step
                done
        done;
       Filter.main_noise matsrc

(*
let binarize =
	toBlack (Matrix.image2tab Main.img) in
        Display.show (Matrix.tab2image mymatrix) Main.display;
*)
